# Reference

<!-- DO NOT EDIT: This document was generated by Puppet Strings -->

## Table of Contents

### Resource types

* [`dsc_xwinrm`](#dsc_xwinrm): The DSC xWinRM resource type. Automatically generated from version 1.0.14

## Resource types

### <a name="dsc_xwinrm"></a>`dsc_xwinrm`

The DSC xWinRM resource type.
Automatically generated from version 1.0.14

#### Properties

The following properties are available in the `dsc_xwinrm` type.

##### `dsc_client_allowunencrypted`

Data type: `Optional[Enum['true', 'false']]`

Enable or disable unencrypted WinRM client

##### `dsc_client_basic`

Data type: `Optional[Enum['true', 'false']]`

Enable or disable basic auth for the WinRM client

##### `dsc_client_certificate`

Data type: `Optional[Enum['true', 'false']]`

Enable or disable certificate auth for the WinRM client

##### `dsc_client_credssp`

Data type: `Optional[Enum['true', 'false']]`

Enable or disable credssp auth for the WinRM client

##### `dsc_client_digest`

Data type: `Optional[Enum['true', 'false']]`

Enable or disable digest auth for the WinRM client

##### `dsc_client_kerberos`

Data type: `Optional[Enum['true', 'false']]`

Enable or disable kerberos auth for the WinRM client

##### `dsc_client_negotiate`

Data type: `Optional[Enum['true', 'false']]`

Enable or disable negotiate auth for the WinRM client

##### `dsc_ensure`

Data type: `Optional[Enum['Present', 'Absent']]`

Ensure

##### `dsc_httpport`

Data type: `Optional[String]`

Set the HTTP WinRM port

##### `dsc_httpscertthumpprint`

Data type: `Optional[String]`

Enter value of HTTPS certificate thumprint

##### `dsc_httpsport`

Data type: `Optional[String]`

Set the HTTPS WinRM port

##### `dsc_maxbatchitems`

Data type: `Optional[String]`

Set the MaxBatchItems value

##### `dsc_maxenvelopesizekb`

Data type: `Optional[String]`

Set the MaxEnvelopeSizekb value

##### `dsc_maxmemorypershellmb`

Data type: `Optional[String]`

Set the MaxMemoryPerShellMB value

##### `dsc_maxproviderrequests`

Data type: `Optional[String]`

Set the MaxProviderRequests value

##### `dsc_maxtimeoutms`

Data type: `Optional[String]`

Set the MaxTimeoutms value

##### `dsc_restartservice`

Data type: `Optional[Boolean]`

Restart the WinRM Service

##### `dsc_service_allowunencrypted`

Data type: `Optional[Enum['true', 'false']]`

Enable or disable unencrypted WinRM service

##### `dsc_service_basic`

Data type: `Optional[Enum['true', 'false']]`

Enable or disable basic auth for the WinRM service

##### `dsc_service_certificate`

Data type: `Optional[Enum['true', 'false']]`

Enable or disable certificate auth for the WinRM service

##### `dsc_service_credssp`

Data type: `Optional[Enum['true', 'false']]`

Enable or disable credssp auth for the WinRM service

##### `dsc_service_kerberos`

Data type: `Optional[Enum['true', 'false']]`

Enable or disable kerberos auth for the WinRM service

##### `dsc_service_negotiate`

Data type: `Optional[Enum['true', 'false']]`

Enable or disable negotiate auth for the WinRM service

#### Parameters

The following parameters are available in the `dsc_xwinrm` type.

* [`dsc_protocol`](#dsc_protocol)
* [`dsc_psdscrunascredential`](#dsc_psdscrunascredential)
* [`name`](#name)
* [`validation_mode`](#validation_mode)

##### <a name="dsc_protocol"></a>`dsc_protocol`

namevar

Data type: `Enum['HTTP', 'HTTPS']`

Listener protocol

##### <a name="dsc_psdscrunascredential"></a>`dsc_psdscrunascredential`

Data type: `Optional[Struct[{ user => String[1], password => Sensitive[String[1]] }]]`

 

##### <a name="name"></a>`name`

namevar

Data type: `String`

Description of the purpose for this resource declaration.

##### <a name="validation_mode"></a>`validation_mode`

Data type: `Enum[property, resource]`

Whether to check if the resource is in the desired state by property (default) or using Invoke-DscResource in Test mode
(resource).

Default value: `property`

